//-----------------------------------------------------------------------
// FCalcDoCalc
//-----------------------------------------------------------------------


//---------------------------------------------------------------------------
// Header Guard
#ifndef FCalcDoCalcH
#define FCalcDoCalcH
//---------------------------------------------------------------------------



//------------------------------------------------------------------------
// system includes
#include <vcl.h>
//-----------------------------------------------------------------------

//---------------------------------------------------------------------------
// calc expression parser
#include "muParser.h"
using namespace mu;
//---------------------------------------------------------------------------

//-----------------------------------------------------------------------
// C++ Builder Stuff
#pragma hdrstop
//-----------------------------------------------------------------------


//---------------------------------------------------------------------------
#define MAX_EVARS 1000
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
extern AnsiString LastResultStr;
extern AnsiString LastExpressionStr;
extern AnsiString LastPureResultStr;
extern double lastevalval;
extern double lastevalval_exposed;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
double* AddVariable(const mu::char_type *a_szName, void *a_pUserData);
bool CalcInit();
void CalcUnInit();
void ClearAllLocalVariables();
void ClearOneLocalVariables(char *varname);
void CreateBuiltInVars();
double ParserDoEval(AnsiString str);
AnsiString SmartLocaleCommaReplace(AnsiString str);
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
extern bool autocreatevars;
extern bool loadingvars;

extern mu::Parser *mparserp;
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
AnsiString DoCalcExpression(AnsiString expressionstr, int triggermethod);
AnsiString SmartFixupExpression(AnsiString str);
//---------------------------------------------------------------------------





//-----------------------------------------------------------------------
#endif
//-----------------------------------------------------------------------


