unit FarrPluginHelpers;

interface
uses
  FarrPluginGlobals;

  procedure ReportErrorToHost(error_string: PChar); cdecl;
  procedure ExecuteCallbackSearchStateChanged();

implementation

  // Helper procedure to report errors back to the host
  procedure ReportErrorToHost(error_string: PChar); cdecl;
  begin
  	Host_SetStrVal(hostptr,'reporterror',error_string);
  end;

  // Helper procedure for state changes
  procedure ExecuteCallbackSearchStateChanged();
  begin
    if(@Host_NotifySearchStateChanged <> NIL) then
    begin
      Host_NotifySearchStateChanged(hostptr,numresultsavailable,searchstate);
    end;
  end;

end.
