#include <windows.h>

BOOL WINAPI DllMain(HINSTANCE hInstance, unsigned long reason, void* lpReserved)
{
	UNREFERENCED_PARAMETER(hInstance);
	UNREFERENCED_PARAMETER(lpReserved);
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }
	return TRUE;
}

extern "C" __declspec(dllexport) BOOL __cdecl FarrSearch(LPSTR lpSearchString)
{
	LPSTR lpString;
	HANDLE hMapping, hMutex, hEvent;
	if ((hMutex = OpenMutex(MUTEX_MODIFY_STATE, FALSE, "FARR_EXTERNALSEARCH_ACTIVE")) != NULL)
	{
		CloseHandle(hMutex);
		hMapping = OpenFileMapping(FILE_MAP_WRITE, FALSE, "FARR_EXTERNALSEARCH_SEARCH_STRING");
		lpString = (CHAR *)MapViewOfFile(hMapping,FILE_MAP_WRITE,0,0,1024);
		lstrcpy(lpString, lpSearchString);
		hEvent = OpenEvent(EVENT_MODIFY_STATE, FALSE, "FARR_EXTERNALSEARCH_PERFORM_SEARCH");
		SetEvent(hEvent);
		UnmapViewOfFile(lpString);
		CloseHandle(hMapping);
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}