unit AdvConfigForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles, FarrPluginGlobals;

type
  TfrmAdvConfig = class(TForm)
    lblLocation: TLabel;
    txtLocation: TEdit;
    dlgLocation: TOpenDialog;
    btnSave: TButton;
    btnCancel: TButton;
    btnBrowse: TButton;
    lblMaxFoundFiles: TLabel;
    txtMaxFoundFiles: TEdit;
    procedure btnBrowseClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAdvConfig: TfrmAdvConfig;

implementation

{$R *.dfm}

procedure TfrmAdvConfig.btnBrowseClick(Sender: TObject);
begin
  dlgLocation := TOpenDialog.Create(self);
  dlgLocation.Options := [ofFileMustExist];
  dlgLocation.Filter := 'Locate.exe|Locate.exe';
  dlgLocation.FilterIndex := 1;
  if dlgLocation.Execute then
    txtLocation.Text := dlgLocation.FileName;

  // Free up the dialog
  dlgLocation.Free;
end;

procedure TfrmAdvConfig.btnCancelClick(Sender: TObject);
var
  Form:TCustomForm;
begin
  Form := GetParentForm(Self);
  Form.ModalResult := mrCancel;
  Form.Hide;
end;

procedure TfrmAdvConfig.btnSaveClick(Sender: TObject);
var
  Form:TCustomForm;
begin
  Form := GetParentForm(Self);
  Form.ModalResult := mrOk;
  Form.Hide;
end;

end.
