#include "stdafx.h"
#include "prefs.h"

extern HMODULE GetThisModuleHandle();

static TCHAR s_configFile[MAX_PATH+1] = {0};

TCHAR* GetConfigFile()
{  
  if (!_tcslen(s_configFile))
  {    
    TCHAR ModulePath[MAX_PATH+1]={'\0'};
    GetModuleFileName( (HMODULE)GetThisModuleHandle(),   ModulePath,  MAX_PATH);
    TCHAR drive[MAX_PATH + 1] = {0};
    TCHAR dir[MAX_PATH + 1] = {0};
    TCHAR name[MAX_PATH + 1] = {0};
    _tsplitpath(ModulePath, drive, dir, name, NULL);
    _sntprintf(s_configFile, MAX_PATH, _T("%s%s%s%s"), drive, dir, _T("advoptions"), _T(".cfg"));
  }
  return s_configFile;
}

DWORD GetOption(LPCTSTR section, LPCTSTR key, LPCTSTR defValue, LPTSTR strBuff, DWORD nSize)
{
  GetPrivateProfileString(section, key, defValue, strBuff, nSize, GetConfigFile());
  return 0;
}

BOOL SetOption(LPCTSTR section, LPCTSTR key, LPCTSTR strBuff)
{
  BOOL ret = WritePrivateProfileString(section, key, strBuff, GetConfigFile());
  return TRUE;
}