#pragma once

#include <windows.h>
#include <tchar.h>
#include <vector>
#include <string>
using namespace std;

typedef struct _PROCESS {
  DWORD       dwProcessId;
  string      ProcessName;
  string      ProcessFullPath;
  string      Owner;
} PROCESS, *PPROCESS;

typedef std::vector<PROCESS> CProcessList;
typedef std::vector<PROCESS>::iterator CProcessListItf;

bool SortByProcessName(const PROCESS& a, const PROCESS& b);
bool EnumProcessList(CProcessList&);
